import math


def computeIntExtT(boundaryResults, boundaryGroups):
	boundariesAtSimulationTime = boundaryResults["boundaries_at_simulation_time"]
	groupTemperatures = list()
	groupTemperaturesDict = dict()
	for boundaryGroup in boundaryGroups:
		for boundary in boundaryGroup:
			# Use a 0.0001 °C threshold to consider equal two temperatures
			boundaryTemperature = math.ceil(boundariesAtSimulationTime[boundary]["temperature"] * 10000.0) / 10000.0
			if not boundaryTemperature in groupTemperaturesDict:
				groupTemperaturesDict[boundaryTemperature] = True
				groupTemperatures.append(boundaryTemperature)
			
	intExtCouple = boundaryResults["int_ext_couple"]		
	couplingsIDs = boundaryResults["monthly_couplings_ids"]
	if intExtCouple >= 0 and intExtCouple < len(couplingsIDs):
		intExtCoupleIDs = couplingsIDs[intExtCouple]
		internalID = intExtCoupleIDs["internal"]
		externalID = intExtCoupleIDs["external"]
		return [boundariesAtSimulationTime[internalID]["temperature"], boundariesAtSimulationTime[externalID]["temperature"]]
	elif len(groupTemperatures) == 2:
		return [max(groupTemperatures[0], groupTemperatures[1]), min(groupTemperatures[0], groupTemperatures[1])]
	
	return [0.0, 0.0]

def computeDeltaT(boundaryResults, boundaryGroups):
	intExtT = computeIntExtT(boundaryResults, boundaryGroups)
	return math.fabs(intExtT[0] - intExtT[1])